<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006-2007 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    k.watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2007 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_FormElementRadio.php,v 1.8 2007/01/21 08:14:45 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * 饸ܥեǥ饹
 *
 * ̾ : ̾ : ̾(name) : (value)
 *   1  :      n     :    1         :  n
 *
 * 󥹥󥹺ˡ
 * // 쥯饹饹ƥå᥽åɤǼ
 * $SyL_FormElementText = SyL_FormElement::createElement( 'radio', 'gender', array( '1'=> '', '2' => '' ) );
 *
 * @package   SyL
 * @author    k.watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2007 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_FormElementRadio.php,v 1.8 2007/01/21 08:14:45 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_FormElementRadio extends SyL_FormElement
{
    /**
     * 󥹥ȥ饯
     *
     * @access public
     * @param string եHTML̾
     * @param string եɽ̾
     * @param string եǤ
     * @param array եǤradio, select, checkboxξΤߡ
     * @param string եǤɲ°
     */
    function SyL_FormElementRadio($name, $display_name, $options=array(), $value=null, $attributes=array())
    {
        $this->type         = 'radio';
        $this->name         = $name;
        $this->display_name = $display_name;
        $this->options      = $options;
        // ǥեͤμ
        $this->value      = ($value === null) ? $this->getParameter() : $value;
        $this->attributes = $attributes;
    }

    /**
     * եHTML
     * С饤
     *
     * @access public
     * @param bool true: html󥳡ɤԤfalse: html󥳡ɤԤʤ
     * @return string եǤHTML
     */
    function getHtmlTag( $html_encode=true )
    {
        $i = 0;
        $options = array();
        foreach ($this->options as $key => $value) {
            $id = $this->form_name . '_' . $this->name . '_' . $i;
            $html_element  = '';
            $html_element .= '<input ';
            $html_element .=   'type="'  . $this->type      . '" ';
            $html_element .=   'id="'    . $id                      . '" ';
            $html_element .=   'name="'  . $this->name . '" ';
            $html_element .=   'value="' . $this->encodeHtml($key)  . '" ';
            $html_element .= $this->getAttribute();
            if ($key == $this->value) {
                $html_element .= ' checked';
            }
            $html_element .= '>';
            $html_element .= '<label for="' . $id . '">' . $value . '</label>';
            $options[] = $html_element;
            $i++;
        }

        return implode( "&nbsp;\r\n", $options );
    }

    /**
     * եHTML
     * С饤
     *
     * @access public
     * @return string եǤHTML
     */
    function getHtmlView()
    {
        $label = '';
        foreach ($this->options as $key => $value) {
            if ($key == $this->value) {
                $label = $value;
                break;
            }
        }
        return $this->encodeHtml($label) . $this->getHtmlHidden();
    }
}


?>
